#!/bin/bash
SCRIPT_ABS_LOCATION="$(realpath "$(dirname "$0")")"

# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/forgejo-backup.env"; /

# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/../logger.sh"; /

# shellcheck disable=SC1090
source "$SCRIPT_ABS_LOCATION/../common-backup.sh"

# shellcheck disable=SC2034
LOG_FILE="$SCRIPT_ABS_LOCATION/forgejo-backup.log"

stop_container "$APP_CONTAINER"

run_duplicati_backup \
  "$BACKUP_CONTAINER" \
  "$BACKUP_DESTINATION" \
  "forgejo" \
  7 \
  "$SFTP_USERNAME" \
  "$SFTP_PASSWORD" \
  "$BACKUP_ENCR_PASSPHRASE" \
  "$SFTP_FINGERPRINT" \
  "$SOURCE_DIR"

start_container "$APP_CONTAINER"

